/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.SmoothDown;

import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.widgets.RunButton;
import static org.visnow.vn.lib.basic.filters.SmoothDown.SmoothDownShared.*;

public class SmoothDownGUI extends javax.swing.JPanel
{

    private Parameters parameters;

    /**
     * Creates new form EmptyVisnowModuleGUI
     */
    public SmoothDownGUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        downsizeUI = new org.visnow.vn.lib.gui.DownsizeUI();
        sigmaSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        runButton = new org.visnow.vn.gui.widgets.RunButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setPreferredSize(new java.awt.Dimension(220, 320));
        setLayout(new java.awt.GridBagLayout());

        downsizeUI.setMinimumSize(new java.awt.Dimension(113, 70));
        downsizeUI.setPreferredSize(new java.awt.Dimension(113, 70));
        downsizeUI.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                downsizeUIStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 1, 0, 1);
        add(downsizeUI, gridBagConstraints);

        sigmaSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("smoothing sigma (relative)"));
        sigmaSlider.setMax(10.0F);
        sigmaSlider.setMinimumSize(new java.awt.Dimension(90, 70));
        sigmaSlider.setPreferredSize(new java.awt.Dimension(200, 70));
        sigmaSlider.setVal(1.0F);
        sigmaSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sigmaSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(sigmaSlider, gridBagConstraints);

        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                runButtonUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        add(runButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_runButtonUserChangeAction
    {//GEN-HEADEREND:event_runButtonUserChangeAction
        parameters.set(SMOOTHDOWN_RUNNING_MESSAGE, (RunButton.RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction

    private void sigmaSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_sigmaSliderStateChanged
    {//GEN-HEADEREND:event_sigmaSliderStateChanged
        sigmaSlider.setVal(Math.max(0, sigmaSlider.getVal()));
//        if (!sigmaSlider.isAdjusting()) {
        parameters.set(SMOOTHDOWN_SIGMA, sigmaSlider.getVal());
        runButton.setPendingIfNoAuto();
//        }
    }//GEN-LAST:event_sigmaSliderStateChanged

    private void downsizeUIStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_downsizeUIStateChanged
    {//GEN-HEADEREND:event_downsizeUIStateChanged
        parameters.set(SMOOTHDOWN_DOWNSIZE, downsizeUI.getDownsize());
        runButton.setPendingIfNoAuto();
    }//GEN-LAST:event_downsizeUIStateChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.lib.gui.DownsizeUI downsizeUI;
    private javax.swing.Box.Filler filler1;
    private org.visnow.vn.gui.widgets.RunButton runButton;
    private org.visnow.vn.gui.widgets.FloatSlider sigmaSlider;
    // End of variables declaration//GEN-END:variables

    public void updateGUI(final ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
        sigmaSlider.setVal(p.get(SMOOTHDOWN_SIGMA));
        if (resetFully) {
            sigmaSlider.setMin(0);
            sigmaSlider.setMax(Math.max(10.f, p.get(SMOOTHDOWN_SIGMA)));
        }
        parameters.setParameterActive(false);
        downsizeUI.setDownsize(p.get(SMOOTHDOWN_DOWNSIZE), new int[]{3, 3, 3});
        parameters.setParameterActive(true);
        runButton.updateAutoState(p.get(SMOOTHDOWN_RUNNING_MESSAGE));
        runButton.updatePendingState(setRunButtonPending);
    }

    public void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

}
